#include "tipovi.h"
#include "slike.h"
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

Elem* ucitaj_listu_piksela(char* ime_fajla) {

	FILE* fajl;
	fajl = fopen(ime_fajla, "r");
	if (fajl == NULL) return NULL;

	Elem* glava = NULL;
	while (!feof(fajl)) {
		Boja boja;
		fscanf_s(fajl, "%d %d %d", &boja.R, &boja.G, &boja.B);
		Elem* novi = malloc(sizeof(Elem));
		if (novi == NULL) return NULL;
		novi->boja = boja;
		if (glava == NULL) {
			novi->sled = NULL;
		}
		else {
			novi->sled = glava;
		}
		glava = novi;
	}

	return glava;
}

void prikaz_piksela(Elem* glava) {
	while (glava != NULL) {
		printf("%d %d %d\n", glava->boja.R, glava->boja.G, glava->boja.B);
		glava = glava->sled;
	}
}

void oslobodi_memoriju(Elem* glava) {
	while (glava != NULL) {
		Elem* stari = glava;
		glava = glava->sled;
		free(stari);
	}
}

void predvidi_boju_na_osnovu_dominantne_boje(Elem* glava) {
	int ucestalosti_boja[] = { 0, 0, 0 }; // R, G, B
	while (glava != NULL) {
		// Uslovi dobijeni empirijskim putem! Po zelji promeniti.
		if (glava->boja.R + glava->boja.G - glava->boja.B > 383) {
			ucestalosti_boja[2]++;
		}
		else if (glava->boja.R > glava->boja.G + glava->boja.B) {
			ucestalosti_boja[0]++;
		}
		else if (glava->boja.G > glava->boja.R + glava->boja.B) {
			ucestalosti_boja[1]++;
		}
		glava = glava->sled;
	}
	printf("Ucestalosti boja svih piksela su (crvena, zelena, zuta): %d %d %d\n", ucestalosti_boja[0], ucestalosti_boja[1], ucestalosti_boja[2]);
	if (ucestalosti_boja[0] > ucestalosti_boja[1] && ucestalosti_boja[0] > ucestalosti_boja[2]) {
		printf("Jabuka je crvena.\n");
	}
	else if (ucestalosti_boja[1] > ucestalosti_boja[0] && ucestalosti_boja[1] > ucestalosti_boja[2]) {
		printf("Jabuka je zelena.\n");
	}
	else if (ucestalosti_boja[2] > ucestalosti_boja[1] && ucestalosti_boja[2] > ucestalosti_boja[0]) {
		printf("Jabuka je zuta.\n");
	}
}
